Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2073825

Summary: Review Request: python-niaarm - A minimalistic framework for numerical association rule mining
Product: [Fedora] Fedora Reporter: Iztok Fister Jr. <iztok>
Component: Package ReviewAssignee: Ben Beasley <code>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: code, package-review
Target Milestone: ---Flags: code: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2022-05-11 01:23:42 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941    

Description Iztok Fister Jr. 2022-04-10 17:21:37 UTC
Spec URL: https://raw.githubusercontent.com/firefly-cpp/rpm-reviews/niaarm/python-niaarm.spec
SRPM URL: https://github.com/firefly-cpp/rpm-reviews/raw/niaarm/python-niaarm-0.1.5-1.fc34.src.rpm
Description: NiaARM is a framework for Association Rule Mining based on nature-inspired algorithms for optimization. The framework is written fully in Python and runs on all platforms. NiaARM allows users to preprocess the data in a
transaction database automatically, to search for association rules and
provide a pretty output of the rules found. This framework also supports
numerical and real-valued types of attributes besides the categorical ones.
Mining the association rules is defined as an optimization problem, and
solved using the nature-inspired algorithms that come from the related
framework called NiaPy.

Fedora Account System Username: iztokf

Comment 1 Ben Beasley 2022-05-01 13:45:15 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== Issues =====

- I can’t find anything licensed CC-BY-SA in the package. If (MIT and CC-BY-SA)
  is really the correct License, you need to to add a licensing breakdown
  comment as in
  https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_multiple_licensing_scenarios.

- Version 0.1.6 is available; please update.

- You can remove

    BuildRequires:  %{py3_dist sphinx}
    BuildRequires:  %{py3_dist sphinx-rtd-theme}
    BuildRequires:  %{py3_dist sphinxcontrib-bibtex}

  and instead change

    %pyproject_buildrequires -r

  to (noting that you could leave “-r”, but I have dropped it because it is now
  the default):

    %pyproject_buildrequires %{?with_doc_pdf:-x docs}

===== Notes (no change required) =====

- If you do want to package the tests, would you consider putting them in a
  separate subpackage with a fully-versioned dependency on the base package?

    %files -n python3-%{pypi_name} -f %{pyproject_files}
    […]
    %exclude %{python3_sitearch}/%{pypi_name}/tests

    %files -n python3-%{pypi_name}-tests
    %{python3_sitearch}/%{pypi_name}/tests

- A man page is always desired for a command-line tool.

  https://docs.fedoraproject.org/en-US/packaging-guidelines/#_manpages

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 67 files have unknown license. Detailed output of
     licensecheck in /home/reviewer/2073825-python-niaarm/licensecheck.txt

     What is CC-BY-SA licensed? See Issues.

[x]: License file installed when any subpackage combination is installed.
[!]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-niaarm
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/firefly-cpp/NiaARM/archive/0.1.5/NiaARM-0.1.5.tar.gz :
  CHECKSUM(SHA256) this package     : 3a7bf11bb282d943ad4afbcf83626f22442aac99247be84c82d9e724853a3d41
  CHECKSUM(SHA256) upstream package : 3a7bf11bb282d943ad4afbcf83626f22442aac99247be84c82d9e724853a3d41


Requires
--------
python3-niaarm (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.10dist(niapy)
    python3.10dist(numpy)
    python3.10dist(pandas)

python-niaarm-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-niaarm:
    python-niaarm
    python3-niaarm
    python3.10-niaarm
    python3.10dist(niaarm)
    python3dist(niaarm)

python-niaarm-doc:
    python-niaarm-doc



Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review -b 2073825
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: SugarActivity, PHP, Java, C/C++, R, Perl, Ocaml, fonts, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH
============================ rpmlint session starts ============================
rpmlint: 2.2.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

python3-niaarm.noarch: W: no-manual-page-for-binary niaarm
python-niaarm-doc.noarch: W: description-shorter-than-summary
 3 packages and 0 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 0.8 s

Comment 2 Iztok Fister Jr. 2022-05-01 19:13:12 UTC
Thank you very much for your review. I am responding with my answers to your comments. Both files were also updated according to
your requirements.

ALL ISSUES::

Comment: - I can’t find anything licensed CC-BY-SA in the package. If (MIT and CC-BY-SA)
  is really the correct License, you need to to add a licensing breakdown
  comment as in
  https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_multiple_licensing_scenarios.

ANSWER: Yes. You are right; only the MIT license should be written down.

Comment: Version 0.1.6 is available; please update.

ANSWER: Done

Comment: - You can remove

    BuildRequires:  %{py3_dist sphinx}
    BuildRequires:  %{py3_dist sphinx-rtd-theme}
    BuildRequires:  %{py3_dist sphinxcontrib-bibtex}

  and instead change

    %pyproject_buildrequires -r

  to (noting that you could leave “-r”, but I have dropped it because it is now
  the default):

    %pyproject_buildrequires %{?with_doc_pdf:-x docs}

ANSWER: Done

Optional issues:

- Tests: I will do it later when the package is imported.

- Man pages: I will ask you to provide a man page. However, the package is now under heavy development, and major changes are expected. Hence, we may
wait for one more month.

Comment 4 Ben Beasley 2022-05-01 20:12:17 UTC
Thanks! Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== Notes (no change required) =====

- Consider putting the tests in a separate subpackage with a fully-versioned
  dependency on the base package.

- A man page is always desired for a command-line tool.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 74 files have unknown license. Detailed output of
     licensecheck in /home/reviewer/2073825-python-niaarm/2073825-python-
     niaarm/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-niaarm
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/firefly-cpp/NiaARM/archive/0.1.6/NiaARM-0.1.6.tar.gz :
  CHECKSUM(SHA256) this package     : 24de81a5c8eea6bf82bc9e83baa7b0da01c83d4bbbd5508abd1e817a355ae8bd
  CHECKSUM(SHA256) upstream package : 24de81a5c8eea6bf82bc9e83baa7b0da01c83d4bbbd5508abd1e817a355ae8bd


Requires
--------
python3-niaarm (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.10dist(niapy)
    python3.10dist(numpy)
    python3.10dist(pandas)

python-niaarm-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-niaarm:
    python-niaarm
    python3-niaarm
    python3.10-niaarm
    python3.10dist(niaarm)
    python3dist(niaarm)

python-niaarm-doc:
    python-niaarm-doc



Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review -b 2073825
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: Haskell, R, Perl, SugarActivity, C/C++, PHP, Ocaml, Java, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH
============================ rpmlint session starts ============================
rpmlint: 2.2.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

python3-niaarm.noarch: W: no-manual-page-for-binary niaarm
python-niaarm-doc.noarch: W: description-shorter-than-summary
 3 packages and 0 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 0.8 s

Comment 5 Gwyn Ciesla 2022-05-02 15:22:40 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-niaarm

Comment 6 Fedora Update System 2022-05-02 18:40:46 UTC
FEDORA-2022-ba77089d01 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2022-ba77089d01

Comment 7 Fedora Update System 2022-05-02 18:40:46 UTC
FEDORA-2022-fb54710903 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2022-fb54710903

Comment 8 Fedora Update System 2022-05-03 14:32:09 UTC
FEDORA-2022-ba77089d01 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2022-ba77089d01 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-ba77089d01

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Fedora Update System 2022-05-03 15:27:59 UTC
FEDORA-2022-fb54710903 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2022-fb54710903 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-fb54710903

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2022-05-11 01:23:42 UTC
FEDORA-2022-fb54710903 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 11 Fedora Update System 2022-05-11 01:34:00 UTC
FEDORA-2022-ba77089d01 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.